Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.1.6 generated on August 25 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## kodo.jdbc.schema
Class Table

    java.lang.Object
      |
      +--kodo.jdbc.schema.NameSet
            |
            +--kodo.jdbc.schema.Table

All Implemented Interfaces:
  Comparable, com.solarmetric.meta.SourceTracker

public class Table
extends NameSet
implements Comparable, com.solarmetric.meta.SourceTracker

Represents a database table.

Constructor Summary
`Table(String name, Schema schema)` Constructor.

Method Summary
`Column` | `addColumn(String name)` Add a column to the table.
`ForeignKey` | `addForeignKey()` Add a foreign key to the table.
`ForeignKey` | `addForeignKey(String name)` Add a foreign key to the table.
`Index` | `addIndex(String name)` Add an index to the table.
`PrimaryKey` | `addPrimaryKey()` Set the primary key for the table.
`PrimaryKey` | `addPrimaryKey(String name)` Set the primary key for the table.
`int` | `compareTo(Object other)`
`Column[]` | `getAutoIncrementColumns()` Return this table's auto-increment columns.
`Column` | `getColumn(String name)` Return the column with the given name, or null if none.
`Column[]` | `getColumns()` Return the table's columns, in alphabetical order.
`ForeignKey` | `getForeignKey(String name)` Return the foreign key with the given name.
`ForeignKey[]` | `getForeignKeys()` Return all foreign keys for the table.
`String` | `getFullName()` Return the table name, including schema, using '.' as the catalog separator.
`Index` | `getIndex(String name)` Return the index with the given name, or null if none.
`Index[]` | `getIndexes()` Return the table's indexes.
`String` | `getName()` Return the name of the table.
`PrimaryKey` | `getPrimaryKey()` Return the primary key for the table, if any.
`Schema` | `getSchema()` Return the schema for the table.
`File` | `getSourceFile()` Return the source file the table was parsed from, if any.
`Column` | `importColumn(Column col)` Import a column from another table.
`ForeignKey` | `importForeignKey(ForeignKey fk)` Import a foreign key; column names must match columns of this table.
`Index` | `importIndex(Index idx)` Import an index; column names must match columns of this table.
`PrimaryKey` | `importPrimaryKey(PrimaryKey pk)` Import a primary key; column names must match columns of this table.
`boolean` | `removeColumn(Column col)` Remove the given column from the table.
`boolean` | `removeForeignKey(ForeignKey fk)` Remove the given foreign key from the table.
`boolean` | `removeIndex(Index idx)` Remove the given index from the table.
`boolean` | `removePrimaryKey()` Remove the primary key from this table.
`void` | `setSourceFile(File source)` Set the source file the table was parsed from, if any.
`String` | `toString()`

Methods inherited from class kodo.jdbc.schema.NameSet
`addName, isNameTaken, removeName`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Table

    public Table(String name,
                 Schema schema)

  Constructor.
  Parameters:
    `name` - the table name
    `schema` - the table schema

Method Detail

### getSchema

    public Schema getSchema()

  Return the schema for the table.

### getName

    public String getName()

  Return the name of the table.

### getFullName

    public String getFullName()

  Return the table name, including schema, using '.' as the catalog separator.

### getSourceFile

    public File getSourceFile()

  Return the source file the table was parsed from, if any.
  Specified by:
    `getSourceFile` in interface `com.solarmetric.meta.SourceTracker`

### setSourceFile

    public void setSourceFile(File source)

  Set the source file the table was parsed from, if any.

### getColumns

    public Column[] getColumns()

  Return the table's columns, in alphabetical order.

### getAutoIncrementColumns

    public Column[] getAutoIncrementColumns()

  Return this table's auto-increment columns.

### getColumn

    public Column getColumn(String name)

  Return the column with the given name, or null if none.

### addColumn

    public Column addColumn(String name)

  Add a column to the table.

### removeColumn

    public boolean removeColumn(Column col)

  Remove the given column from the table.
  Returns:
    true if the column was removed, false if not in the table

### importColumn

    public Column importColumn(Column col)

  Import a column from another table.

### getPrimaryKey

    public PrimaryKey getPrimaryKey()

  Return the primary key for the table, if any.

### addPrimaryKey

    public PrimaryKey addPrimaryKey()

  Set the primary key for the table.

### addPrimaryKey

    public PrimaryKey addPrimaryKey(String name)

  Set the primary key for the table.

### removePrimaryKey

    public boolean removePrimaryKey()

  Remove the primary key from this table.
  Returns:
    true if there was a pk to remove, false otherwise

### importPrimaryKey

    public PrimaryKey importPrimaryKey(PrimaryKey pk)

  Import a primary key; column names must match columns of this table.

### getForeignKey

    public ForeignKey getForeignKey(String name)

  Return the foreign key with the given name. If multiple foreign keys have the name, the first match is returned.

### getForeignKeys

    public ForeignKey[] getForeignKeys()

  Return all foreign keys for the table.

### addForeignKey

    public ForeignKey addForeignKey()

  Add a foreign key to the table.

### addForeignKey

    public ForeignKey addForeignKey(String name)

  Add a foreign key to the table. Duplicate key names are not allowed.

### removeForeignKey

    public boolean removeForeignKey(ForeignKey fk)

  Remove the given foreign key from the table.
  Returns:
    true if the key was removed, false if not in the table

### importForeignKey

    public ForeignKey importForeignKey(ForeignKey fk)

  Import a foreign key; column names must match columns of this table.

### getIndexes

    public Index[] getIndexes()

  Return the table's indexes.

### getIndex

    public Index getIndex(String name)

  Return the index with the given name, or null if none.

### addIndex

    public Index addIndex(String name)

  Add an index to the table.

### removeIndex

    public boolean removeIndex(Index idx)

  Remove the given index from the table.
  Returns:
    true if the index was removed, false if not in the table

### importIndex

    public Index importIndex(Index idx)

  Import an index; column names must match columns of this table.

### compareTo

    public int compareTo(Object other)

  Specified by:
    `compareTo` in interface `Comparable`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.1.6 generated on August 25 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001,2002 SolarMetric, Inc. All Rights Reserved.